#include <avr/io.h>
#include <avr/interrupt.h>
#include <TinyWireM.h>
//#include <SoftwareSerial.h>

#define I2C_SLAVE_ADDR  0x26            // i2c slave address (38)              
#define LED_PIN         8              // ATtiny Pin 5 (PB2)

//#define serial_pin_out (1 << PA1)
#define NPTS 100

//SoftwareSerial mySerial(0, 1);//rx, tx
int lo,hi,sound_wave = 0;


int test = 0;
int x = 3;

void setup()
{
  //CLKPR = (1 << CLKPCE);
  //CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);

  ADMUX = (1 << REFS1) | (0 << REFS0) // 1.1V ref
    | (0 << MUX5)| (1 << MUX4) | (0 << MUX3) | (0 << MUX2) | (0 << MUX1) | (1 << MUX0); //x20 PA2-PA3 (ADC2-ADC3)
  ADCSRA = (1 << ADEN)
    | (1 << ADPS2) | (1 << ADPS1) | (0 << ADPS0); // prescaler /64
  ADCSRB = (1 << BIN); // bipolar mode

  //mySerial.begin(4800);//115200);// set the data rate for the SoftwareSerial port
  pinMode(LED_PIN,OUTPUT);             // for general DEBUG use
  Blink(LED_PIN, 2);
  TinyWireM.begin(); // join i2c bus (address optional for master)
  delay (3000);
}

void loop()
{
  mic_val();

  if(sound_wave > 1000){
    Blink(LED_PIN, 1); 
    sendByte();
    //delay(300);
  }
  //receiveByte();
  
}

void mic_val(){
  // for (int i = 0; i < NPTS; i++) {
  ADCSRA |= (1 << ADSC);// initiate conversion
  while (ADCSRA & (1 << ADSC)){// wait for completion
    lo = ADCL; // save result
    hi = ADCH;
    if (hi < 2){
      sound_wave = 512 + 256*hi + lo;
    }
    else{
      sound_wave = 256*hi + lo - 512;
    }
  }
  //} 
}

void sendByte(){
  //to Send
  TinyWireM.beginTransmission(I2C_SLAVE_ADDR); // setup slave's adress(7 bit adress)
  byte send_byte = 'x';
  TinyWireM.send(send_byte); // buffer up bytes to send - can be called multiple times 
  TinyWireM.endTransmission();// actually send the bytes in the buffer
  // returns (optional) 0 = sucess or see USI_TWI_Master.h for error codes

  //mySerial.write(x);
}

void receiveByte(){
  if(TinyWireM.available()){
    //To Receive:
    byte byteRcvd = 0;
    TinyWireM.requestFrom(I2C_SLAVE_ADDR, 1);      // reads 1 byte from slave's address(usage optional) returns 0= success or see USI_TWI_Master.h for error codes
    test = TinyWireM.receive();                 // returns the next byte in the received buffer - called multiple times
  }
}

void Blink(byte led, byte times){ // poor man's GUI
  for (byte i=0; i< times; i++){
    digitalWrite(led,HIGH);
    delay (250);
    digitalWrite(led,LOW);
    delay (175);
  }
}






